SHELL = sh
#
#  defaults for MPI
#  using mpicc, mpif77 
#				Gundolf Haase, University of Graz
#				gundolf.haase@uni-graz.at
#
##############################################################################
#									     #
#		Add your own compiler flags or additional libraries	     #
#									     #
##############################################################################

#CFLAGS	= -O
CFLAGS	= -DUNDER -DANSI_C -IC:\Programme\MPICH2\include
CPPFLAGS= 
FFLAGS	= 
LDFLAGS	= -lm -LC:\Programme\MPICH2\lib -lmpich2 -lfmpich2g
#LDFLAGS	= -lm 
#-lmpi

#		Flags for mpirun
#			Optional list of hosts
MPINODES= ../mynode
#			Use  -lamd   for LAM-MPI 
#MPIFLAGS= -lamd 

#MPIBOOT	= lamboot
##MPIBOOT= lamboot -v $(MPINODES)
#MPICLEAN= lamclean
MPICLEAN= echo

##############################################################################
#									     #
#		There should be no need to change something below this line! #
#			(But it could be necessary sometimes)		     #
#									     #
##############################################################################

F77	= mpif77
#CC      = mpicc
CC      = C:\Dev-Cpp\bin\gcc
#CC	= mpicc_lam 
#CC	= mpicc_mpich

CPP	= ${CC}


#MPIRUN  = mpirun
MPIRUN  = C:\Programme\MPICH2\bin\mpiexec
#MPIRUN	= mpirun_mpich

#		 Some standards
ARFLAGS	= ruv
TARFLAGS= cf 

AR	= ar $(ARFLAGS)
MAKE	= make
RANLIB	= echo
RM      = rm -f
TAR	= tar $(TARFLAGS)
SYMLNK	= ln 

#
.SUFFIXES: .f .F .c .cc .o .a
.f.o:
	$(F77) -c $(FFLAGS) $<
.F.o:
	$(F77) -c $(FFLAGS) $<
.c.o:
	$(CC) -c $(CFLAGS)  $<
.cc.o:
	$(CPP) -c $(CPPFLAGS)  $<
.o.a:
	$(AR) $(ARFLAGS) $@ $%
	$(RANLIB) $@

.f.a:
	$(F77) -c $(FFLAGS) $<
	$(AR) $(ARFLAGS) $@ $%
	$(RANLIB) $@
	$(RM) $%

.F.a:
	$(F77) -c $(FFLAGS) $<
	$(AR) $(ARFLAGS) $@ $%
	$(RANLIB) $@
	$(RM) $%

.c.a:
	$(CC) -c $(CFLAGS) $(CPPFLAGS) $<
	$(AR) $(ARFLAGS) $@ $%
	$(RANLIB) $@
	$(RM) $%

