SHELL = sh
#
#  defaults for MPI
#  using mpicc, mpif77
#				Gundolf Haase, Johannes Kepler University Linz
#				ghaase@numa.uni-linz.ac.at
#
##############################################################################
#									     #
#		Add your own compiler flags or additional libraries	     #
#									     #
##############################################################################

WARNING = -W -Wall -Wfloat-equal -Wshadow
#  -W -Wall -Wunreachable-code
#          -Wredundant-decls -Winline -Weffc++ -Woverloaded-virtual

CFLAGS	= -O
#CFLAGS	= -DUNDER -DANSI_C
CXXFLAGS= -O $(WARNING)
FFLAGS	=
#LDFLAGS	= -lm -L/usr/lib/lam/lib
LDFLAGS	= -lm

# MPIDIR = /usr/local/mpich-1.2.7/ch_p4/bin
MPIDIR = /opt/mpich/ch-p4/bin

#-lmpi

#		Flags for mpirun
#			Optional list of hosts
MPINODES= ../mynode
#			Use  -lamd   for LAM-MPI
#MPIFLAGS= -lamd

#MPIBOOT	= lamboot
##MPIBOOT= lamboot -v $(MPINODES)
#MPICLEAN= lamclean
MPICLEAN= echo

##############################################################################
#									     #
#		There should be no need to change something below this line! #
#			(But it could be necessary sometimes)		     #
#									     #
##############################################################################

F77	= $(MPIDIR)/mpif77
CC      = $(MPIDIR)/mpicc
#CC      = /usr/lib/lam/bin/mpicc
#CC	= mpicc_lam
#CC	= mpicc_mpich

CXX	= $(MPIDIR)/mpicxx


MPIRUN  = $(MPIDIR)/mpirun
#MPIRUN  = /usr/lib/lam/bin/mpirun
#MPIRUN	= mpirun_mpich

#		 Some standards
ARFLAGS	= ruv
TARFLAGS= cf

AR	= ar $(ARFLAGS)
MAKE	= make
RANLIB	= echo
RM      = rm -f
TAR	= tar $(TARFLAGS)
SYMLNK	= ln

#############################################

clean:
	$(RM) *.o $(PROGRAM)

docu:
# 	echo $(CURDIR)
	kdoc -f html -d DOCU -n $(PROGRAM) -p *.h

#############################################
.SUFFIXES: .f .F .c .cpp .o .a
.f.o:
	$(F77) -c $(FFLAGS) $<
.F.o:
	$(F77) -c $(FFLAGS) $<
.c.o:
	$(CC) -c $(CFLAGS)  $<
.cpp.o:
	$(CXX) -c $(CXXFLAGS)  $<
.o.a:
	$(AR) $(ARFLAGS) $@ $%
	$(RANLIB) $@

.f.a:
	$(F77) -c $(FFLAGS) $<
	$(AR) $(ARFLAGS) $@ $%
	$(RANLIB) $@
	$(RM) $%

.F.a:
	$(F77) -c $(FFLAGS) $<
	$(AR) $(ARFLAGS) $@ $%
	$(RANLIB) $@
	$(RM) $%

.c.a:
	$(CC) -c $(CFLAGS) $<
	$(AR) $(ARFLAGS) $@ $%
	$(RANLIB) $@
	$(RM) $%

.cpp.a:
	$(CXX) -c $(CXXFLAGS) $<
	$(AR) $(ARFLAGS) $@ $%
	$(RANLIB) $@
	$(RM) $%


