#include <iostream>
using namespace std;
#include <mpi.h>

void greetings(const MPI::Intracomm& icomm)
{
    int num  = icomm.Get_size();
    int myid = icomm.Get_rank();    
    int reslen;
    char *name  = new char [MPI::MAX_PROCESSOR_NAME], 
         *chbuf = new char [MPI::MAX_PROCESSOR_NAME];
   
    MPI::Get_processor_name( name, reslen);

    if(myid==0)
    {
      cout << "   " << myid << " runs on " << name << endl;
      for(int i=1; i<num; ++i)
      {
        MPI::Status stat;

	icomm.Recv(chbuf,MPI::MAX_PROCESSOR_NAME,MPI::CHAR,MPI::ANY_SOURCE,
          MPI::ANY_TAG, stat);
	
/*	icomm.Recv(chbuf,MPI::MAX_PROCESSOR_NAME,MPI::CHAR,i,
          MPI::ANY_TAG,stat);*/
	  
        cout << "   " << stat.Get_source() << " runs on " << chbuf;
	cout << " (length: " << stat.Get_count(MPI::CHAR) << " )" << endl;
	//  stat.Get_error()	// Error code
      }
    }
    else
    {
        int dest = 0;
	icomm.Send(name,sizeof(name)+1,MPI::CHAR,dest,myid);
    }
   delete [] chbuf; delete [] name; 
}
