//		MPI code in C++.
//		See [Gropp/Lusk/Skjellum, "Using MPI", p.33/41 etc.]
//		and  /opt/mpich/include/mpi2c++/comm.h  for details

#include <iostream>
using namespace std;
#include <mpi.h>
#include "header.h"

int main(int argc,char* argv[])
{   
    MPI::Init(argc,argv);
  
    MPI::Intracomm icomm(MPI::COMM_WORLD);
    
    int numprocs = icomm.Get_size();
    int myid     = icomm.Get_rank();

    if (myid == 0)
    {
       cout << "\n There are " << numprocs << " processes running.\n \n";
    }

    greetings(icomm);

    if (myid == 0) cout << endl;
    
    MPI::Finalize();
    
    return 0;
}

            
