/* 
	Copy the accumulated diagonal of sk into d
	
	IN:	nx, ny	number of points in x/y-direction
		sk	matrix
		id	crs pointer of sk (points at last element in row)
	OUT:	d	diagonal of sk
*/
#include <mpi.h>
#include "header.h"

void AccuDiag(const int nx, const int ny, const double sk[], const int id[], double d[], 
	const int neigh[], const int color, const MPI::Intracomm& icomm)
{
    const int nd = (nx+1)*(ny+1);
          int ia = 0;
    for (int i=0; i < nd; ++i) 
    {
       d[i] = sk[ia];
       ia   = id[i]+1;
    }
    VecAccu(nx, ny, d, neigh, color, icomm); 
    return;
} 

