/*  Apply b.c. defined in u on matrix and right hand side	*/
/*  via penalty method. 					*/

void ApplyDirichletBC(const int nx, const int ny, const int neigh[], 
	const double u[], double sk[], const int id[], const int* , double f[])
// 	const double u[], double sk[], const int id[], const int ik[], double f[])
{
  const double PENALTY=1e6;
  const int dx = 1,
            dy = nx+1,
            bl  = 0,
            br  = nx,
            tl  = ny*(nx+1),
            tr  = (ny+1)*(nx+1)-1;
  const int start[4] = { bl, br, tl, bl},
            end[4]   = { br, tr, tr, tl},
	    step[4]  = { dx, dy, dx, dy};
 
  for (int j=0; j<4; j++)
  {
    if (neigh[j]<0)
    {
      for (int i=start[j]; i<=end[j]; i += step[j])
      {
	int id1 = (i==0) ? 0 : id[i-1]+1;
	sk[id1] = PENALTY;		/* matrix weighted scaling feasible */
	f[i] = PENALTY*u[i];
      }
    }
  }
 return;
}
