#define MAXLEVEL 20

/* this structure stores all pointers to vectors, matrices of all elevels */

typedef struct 
{ int		nx[MAXLEVEL],		/* intervalls in x/y direction */
		ny[MAXLEVEL];
				/* pointers for array .. on all levels */
  int		*id[MAXLEVEL],		/* row end pointer       */	
  		*ik[MAXLEVEL];		/* column index          */
  double	*sk[MAXLEVEL],		/* matrix entries        */
  		*u[MAXLEVEL],		/* solution/correction   */
		*f[MAXLEVEL],		/* r.h.d/defect          */
		*dd[MAXLEVEL],		/* accumulated diagonal  */
		*aux[MAXLEVEL];		/* aux. vector (d,w,...) */
} PointerStruct;


/* this structure stores control parameters of the multigrid algorithm */

typedef struct 
{ int		cycle,			/* kind of mg cycle (1/2) */
		npre, npost;      	/* number of pre/postsmoothing sweeps */             
} ControlStruct;
