/* 
	Copy the accumulated diagonal of sk into d
	
	IN:	nx, ny	number of points in x/y-direction
		sk	matrix
		id	crs pointer of sk (points at last element in row)
	OUT:	d	diagonal of sk
*/
#include <mpi.h>

void AccuDiag(nx, ny, sk, id, d, neigh, color, myid,
         icomm)
int nx, ny, neigh[], color, myid;
MPI_Comm icomm;
double sk[], d[];
int *id;
{
    int i, ia, nd;
    nd = (nx+1)*(ny+1);
    ia = 0;
    for (i = 0; i < nd; i++) 
    {
       d[i] = sk[ia];
       ia   = id[i]+1;
    }
    VecAccu(nx, ny, d, neigh, color,  myid, icomm); 
    return;
} 

