
/* 
   (0,1) * (0,1) is divided into procx * procy subdomains 
   numbered row by row,
   according to myid, the coordinates of the lower left corner
   (xl,yb) and the upper right corner (xr,yt) are generated

	IN:  	myid	  process id
		procx	  number of subdomains in x-direction
		procy	  number of subdomains in x-direction
	OUT:    (xl,yb)   coordinates of the lower left corner
		(xr,yt)   coordinates the upper right corner
*/

void IniCoord(myid, procx, procy, xl, xr, yb, yt)
int myid, procx, procy;
double *xl, *xr, *yb, *yt;
{
    double hx, hy;
    int kx, ky;

    kx = myid % procx;
    ky = myid / procx;
 
    hx = 1. / procx;
    hy = 1. / procy;

					/* subdomain - part of unit square */
    *xl = kx * hx;                      /* left    */
    *xr = (kx + 1) * hx;                /*  right  */
    *yb = ky * hy;                      /*  bottom */
    *yt = (ky + 1) * hy;                /*  top */

    return;
} 

