/*
	Computes the rows (iza..ize) of w := w + alfa * sk * u   iff alfa >0
		                       w := sk * u              iff alfa ==0

	IN:	izf	first row
		izl	last row
		u	vector
		id, ik	crs pointers of sk
		sk	symmetric matrix
		alfa	coefficient
	I/O	w	vector
*/
		 
 
void  CrsMult(iza, ize, w, u, id, ik, sk, alfa)
int iza, ize, *id, *ik;
double  w[], u[], sk[], alfa;
{

    int i, j, ij, ij1, ij2, n;
    double ui, wi, fak, dzero = 0. ;

    if (iza == 0)  ij2 = -1;
      else ij2 = id[iza-1];
    
    if (alfa == 0.) 
    {
	n = ize - iza +1;
	vdcopy(n, &w[iza], 1, &dzero, 0);
	fak = 1.;
    } 
    else 
    {
        fak = alfa;
    }

    for (i = iza; i <= ize; i++) 
    {
      ij1 = ij2 + 1;
      ij2 = id[i];
      ui  = u[i];
      wi  = sk[ij1] * ui;
      ui *= fak;
      for (ij = ij1+1; ij <=ij2; ij++) 
      {
	j = ik[ij];
	if (j <= ize) 
        {
	   wi   += sk[ij] * u[j]; 
	   w[j] += sk[ij] * ui; 
 	 }
      }	
      w[i] += fak * wi;
    }
    return;
}
