#include <stdio.h>
#include <stdlib.h>
#include "mpi.h"

void Send_ProcD(to,nin,xin,icomm)

int    to,nin;
MPI_Comm icomm;
double *xin;
{
  int  tag, info;
  
  tag = 0;
  info = MPI_Send(&nin,1,MPI_INT,to,tag,icomm);
  
  if (info!=MPI_SUCCESS) 
        { printf("\n Send_ProcD : %d \n",info); exit(-3); }
           
  if (nin > 0)
     info = MPI_Send(xin,nin,MPI_DOUBLE,to,tag,icomm);

  return;
}



void Recv_ProcD(from,nout,xout,maxbuf,icomm)

int    from, *nout, maxbuf;
MPI_Comm icomm;
double *xout;
{
  int        tag, info;
  MPI_Status stat;
  
  tag  = MPI_ANY_TAG;
  
  info = MPI_Recv(nout,1,MPI_INT,from,tag,icomm, &stat);
  
  if (info!=MPI_SUCCESS) 
        { printf("\n Recv_ProcD : %d \n",info); exit(-3); }
  
  if (*nout>maxbuf) {	printf("\n Recv_ProcD : maxbuf too small \n");
  			exit(-3); }
           
  if (*nout > 0)
     info = MPI_Recv(xout,*nout,MPI_DOUBLE,from,tag,icomm, &stat);

  return;
}



void ExchangeD(yourid,nin,xin,nout,xout,maxbuf,icomm)

int    yourid,nin,*nout,maxbuf;
MPI_Comm icomm;
double *xin,*xout;
{
  int myid,info;
  
  if (yourid < 0) { *nout = -1; return; }
  
  info = MPI_Comm_rank(icomm,&myid);

  if (myid < yourid)
     { Send_ProcD(yourid,nin,xin,icomm);
       Recv_ProcD(yourid,nout,xout,maxbuf,icomm); }
    else
     { Recv_ProcD(yourid,nout,xout,maxbuf,icomm);
       Send_ProcD(yourid,nin,xin,icomm); }
  
  return;
}
