/*
   (0,1) * (0,1) is divided into procx * procy subdomains 
   numbered row by row,
   according to myid, the array neigh contains the id's
   of the neighbors at South, East, North, West
   
	IN:  	myid	  process id
		procx	  number of subdomains in x-direction
		procy	  number of subdomains in x-direction
	OUT     neigh     id's of neighbors
		color     black/white coloring (check board) of subdomains   	
*/


void IniGeom(myid,procx,procy,neigh,color)

int myid,procx,procy,neigh[4],*color;
{
 int kx,ky;
 
 ky = myid/procx;
 kx = myid - ky*procx;		/*    MOD(myid,procx)    */


 neigh[0] = (ky == 0)       ?  -1 : myid-procx;		/*   South   */
 neigh[1] = (kx == procx-1) ?  -1 : myid+1;		/*   East    */
 neigh[2] = (ky == procy-1) ?  -1 : myid+procx;		/*   North   */
 neigh[3] = (kx == 0)       ?  -1 : myid-1;		/*   West    */

 *color = (kx+ky) & 1 ;
 return;
}
