
/*
	Copy the values of w corresponding to the boundary
	South (ib==1), East (ib==2), North (ib==3), West (ib==4)
	onto s 
	
	IN:	ib	define piece of boundary
		nx, ny  number of intervals in x/y direction
		w	vector
	OUT:	s	vector of boundary values
*/
	
void GetBound(ib,nx,ny,w,s)
int nx,ny,ib;
double w[], s[];
{
  int i,j,dx,dy,tl,tr,bl,br;
 
  dx = 1;
  dy = nx+1;
  bl  = 0;
  br  = nx;
  tl  = ny*(nx+1);
  tr  = (ny+1)*(nx+1)-1; 
  switch (ib)
    {
    case 1:
      {
	for (i=bl, j=0; i<=br; i++,j++)
	     s[j] = w[i];
 	break;
      }
    case 3:
      {  
	for (i=tl, j=0; i<=tr; i++,j++)
	     s[j] = w[i];
 	break;
      }
    case 4:
      {
	for (i=bl, j=0; i<=tl; i+=dy,j++)
	     s[j] = w[i];
  	break;
      }
    case 2:
      { 
	for (i=br, j=0; i<=tr; i+=dy,j++)
	     s[j] = w[i];
  	break;
      }
    default:
      ;
    }
  return;     
}

 

 
