#include <math.h>
#include <stdio.h>
#include <mpi.h>

void JacobiSmooth(nx, ny, neigh, color, myid, icomm, 
		     sk, id, ik, f, u, dd, aux, maxiter )
int    nx,ny,*neigh,color,myid,*id,*ik,maxiter;
MPI_Comm icomm;
double *sk, *f, *u, *dd, *aux;
{
  double *r, dzero=0, omega;
  int nnode, iter;
  
  omega   = 0.8;
  
  nnode = (nx+1)*(ny+1); 
  r     = aux;					/* ( and  w = r ! )   */
  						/* no inner product ! */
  /* Iteration sweeps */
  iter  = 0;
  while ( maxiter>iter)
  {
    iter++;
    
    vdcopy(nnode, r, 1, f, 1);			/*                 */
    CrsMult(0, nnode-1, r, u, id, ik, sk, -1.0);/*  r := f - K*u   */

    vddiv(nnode, r, 1, r, 1, dd, 1);		/*  w := D^{-1}*r  */ 
    VecAccu(nx,ny,r,neigh,color,myid,icomm);	/*  dist.-->acc.   */ 
    
    vdaxpy(nnode, u, u, omega, r );		/*  u := u + om*w  */  
    
/*    if (myid==0)  printf("Iteration %u : %g\n",iter);     */
  }
  
  return;
}
