#include <stdlib.h>
#include <malloc.h>
#include <mpi.h>

void VecAccu(nx,ny,w,neigh,color,myid,icomm)
int nx,ny,myid,*neigh,color;
MPI_Comm icomm;
double w[];
{
  static int count = 0,lnx, lny, zero=0;
  static double *South_in, *East_in, *North_in, *West_in,
    *South_out, *East_out, *North_out, *West_out, dzero = 0.;
  int nnx, nny, ndiag, nhor, iediag, iehor, nin, j;

 int  nout[4],i;

 nnx = nx+1;
 nny = ny+1;

 if(count==0)
   {
     South_in = (double *)malloc(nnx*sizeof(dzero));
     East_in  = (double *)malloc(nny*sizeof(dzero));
     North_in = (double *)malloc(nnx*sizeof(dzero));
     West_in  = (double *)malloc(nny*sizeof(dzero));
     South_out = (double *)malloc(nnx*sizeof(dzero));
     East_out  = (double *)malloc(nny*sizeof(dzero));
     North_out = (double *)malloc(nnx*sizeof(dzero));
     West_out  = (double *)malloc(nny*sizeof(dzero));
     lnx = nnx;
     lny = nny;
     count = 1;
   }
 else
   {
     if(nnx>lnx)
       {
         South_in  = (double *)realloc(South_in, nnx*sizeof(dzero));
         North_in  = (double *)realloc(North_in, nnx*sizeof(dzero));
         South_out = (double *)realloc(South_out, nnx*sizeof(dzero));
         North_out = (double *)realloc(North_out, nnx*sizeof(dzero));
         lnx = nnx;
       }
     if(nny>lny)
       {
         East_in  = (double *)realloc(East_in, nny*sizeof(dzero));
         West_in  = (double *)realloc(West_in, nny*sizeof(dzero));
         East_out = (double *)realloc(East_out, nny*sizeof(dzero));
         West_out = (double *)realloc(West_out, nny*sizeof(dzero));
         lny = nny;
      }
   }

 nin = nnx;
 GetBound(1,nx,ny,w,South_in);
 GetBound(3,nx,ny,w,North_in);

 if (color==0) 
    {
       ExchangeD(neigh[0],nin,South_in,&nout[0],South_out,nin,icomm);
       ExchangeD(neigh[2],nin,North_in,&nout[2],North_out,nin,icomm);
    }
   else
    {
       ExchangeD(neigh[2],nin,North_in,&nout[2],North_out,nin,icomm);
       ExchangeD(neigh[0],nin,South_in,&nout[0],South_out,nin,icomm); 
    }
 
 if (neigh[0]>=0)  AddBound(1,nx,ny,w,South_out);
 if (neigh[2]>=0)  AddBound(3,nx,ny,w,North_out);
 

 nin =  nny;
 GetBound(2,nx,ny,w,East_in);
 GetBound(4,nx,ny,w,West_in);


 if (color==0) 
    {  
       ExchangeD(neigh[1],nin,East_in,&nout[1],East_out,nin,icomm);
       ExchangeD(neigh[3],nin,West_in,&nout[3],West_out,nin,icomm);  
    }
   else
    {  
       ExchangeD(neigh[3],nin,West_in,&nout[3],West_out,nin,icomm);
       ExchangeD(neigh[1],nin,East_in,&nout[1],East_out,nin,icomm);  
    }
 
 if (neigh[1]>=0)   AddBound(2,nx,ny,w,East_out);
 if (neigh[3]>=0)   AddBound(4,nx,ny,w,West_out);

 return;
}


void FreeVecAccu()
{
 static double *South_in, *East_in, *North_in, *West_in,
    *South_out, *East_out, *North_out, *West_out;
    
 free(South_in);  free(East_in);  free(North_in);  free(West_in);
 free(South_out); free(East_out); free(North_out); free(West_out);
 return;
}
