#include <iostream>
#include <vector>
#include <cassert>
using namespace std;

#include "group.h"

// -----------------------------------------------------------------------------
Communicator::Communicator(const MPI::Intracomm &parent_comm,
                           const vector<int> &proc_list,
                           const vector< vector<int> > &node2proc )
 : procs_(proc_list), parent_comm_(parent_comm), comm_(MPI::COMM_NULL),
   buf2loc_(0), isvalid_(false), isroot_(parent_comm.Get_rank()==proc_list[0])
{
 const int myrank = parent_comm.Get_rank();
 isvalid_ = find(proc_list.begin(), proc_list.end(), myrank) != proc_list.end();

 const MPI::Group &glob_group = parent_comm.Get_group();
       MPI::Group sub_group( glob_group.Incl(proc_list.size(),&proc_list[0]) );

 comm_ = parent_comm.Create(sub_group);
 sub_group.Free();
 
//  cout << parent_comm << "    " << comm_ << "    " << sub_group << "  ()("<<myrank<<")()  " 
//  << sub_group.Get_size() << "    " <<  sub_group.Get_rank() << " :: ";
//  for (int i=0; i<sub_group.Get_size(); ++i)
//     cout << "   " << procs_[i];
//  cout << endl;
 
 if (isvalid_)
 {
   vector<int> tmp;
   tmp.reserve( node2proc.size() );
   for (unsigned int i=0; i<node2proc.size(); ++i)
   {
     if ( node2proc[i] == procs_ )  tmp.push_back( i );
   }
   buf2loc_ = tmp;
   
//  if (myrank==2)
//  {
// /*   cout << "GG  " << buf2loc_.size() << "   " << buf2loc_.capacity() << endl;*/
//    for (unsigned int i=0; i<buf2loc_.size(); ++i)
//        cout << "  " << buf2loc_[i];
//    cout << endl;
//  }
 }
 return;
}
// -----------------------------------------------------------------------------
Communicator::Communicator()
 : procs_(0), parent_comm_(MPI::COMM_NULL), 
   comm_(MPI::COMM_NULL), buf2loc_(0), isvalid_(false), isroot_(true)
{}

// -----------------------------------------------------------------------------
Communicator::Communicator(const Communicator &orig)
 : procs_(orig.procs_), parent_comm_(orig.parent_comm_), 
   comm_(orig.comm_), buf2loc_(orig.buf2loc_), 
   isvalid_(orig.isvalid_), isroot_(orig.isroot_)
{}

// -----------------------------------------------------------------------------
Communicator::~Communicator()
{
/*  comm_.Free();*/
}

// -----------------------------------------------------------------------------

// -----------------------------------------------------------------------------

//##############################################################################
