#include <iostream>
#include <vector>
#include <set>
#include <cassert>
using namespace std;
#include <mpi.h>
// #include <mpi2c++/group.h>

#include "mesh.h"
#include "group.h"

//  man -M /opt/mpich/man mpiCC


int main(int argc, char* argv[])
{
    MPI::Init(argc,argv);
    MPI::Intracomm icomm(MPI::COMM_WORLD);
    int numprocs = icomm.Get_size();
    int myrank   = icomm.Get_rank();
//##############################################################################
//  Test mit Gruppen von proc.
//##############################################################################
//  cout << endl;
//  icomm.Barrier(); 
//  MPI::Group glob_group( icomm.Get_group() );
//  int gn[] = {0,2};
// 
//  MPI::Group sub_group( glob_group.Incl(2,gn) );
//  MPI::Intracomm sub_comm( icomm.Create(sub_group) );
// 
//  cout << "subgroup : " << sub_group.Get_size() 
//          << "  " << sub_group.Get_rank() << endl;
// /* icomm.Barrier();*/
//   cout << icomm << "    " << sub_comm << "    " << sub_group << "  ()("<<myrank<<")()  " 
//  << sub_group.Get_size() << "    " <<  sub_group.Get_rank() << " :: ";
//  for (int i=0; i<sub_group.Get_size(); ++i)
//     cout << "   " << gn[i];
//  cout << endl;
// /*  if (myrank == gn[0] || myrank == gn[1])*/
//  if (sub_comm != MPI::COMM_NULL)
//  {
//         cout << myrank << "  subcomm : " << sub_comm.Get_size() 
//          << "  " << sub_comm.Get_rank() << endl;
// 
//     double dsend=myrank,drecv;
//     sub_comm.Sendrecv
//        ( &dsend,1,MPI::DOUBLE, 1-sub_group.Get_rank(),1,
//          &drecv,1,MPI::DOUBLE, 1-sub_group.Get_rank(),1 );
// 
//     cout << sub_group.Get_rank() << " ## " << dsend << "  " << drecv << endl;
//  }
// icomm.Barrier();
//#############################################################################
/* string filename("mesh_0.txt");
 const int elmdist[] = {0,0,1,1,2,2,3,3};// nur  mesh_0.txt*/
 
 string filename("mesh_1.txt");
 const int elmdist[] = 
             {0,0,0,0,1,1,1,1,
              0,0,0,0,1,1,1,1,
              2,2,2,2,3,3,3,3,
              2,2,2,2,3,3,3,3};// nur  mesh_1.txt
 
 Mesh globmesh(filename);
//  cout << globmesh << endl;
 
 Mesh locmesh( myrank, elmdist, globmesh);
 
 //  Local mesh in global node numbering
//  cout << locmesh << endl;
 
//  vector<int> l2g;   // local to global mapping of node numbering
//  locmesh.ConvertToLocalNodeNumbering(l2g);
 
 // l2g contains also the nodelist for 'proc' 
 
//  for (int i=0; i<l2g.size(); ++i)
//     cout << "   " << l2g[i] << endl;
//  cout<< endl;
 
 //  Local mesh in local node numbering
//  cout << locmesh << endl;
 
 
 // try
//  int va[] = {0,1,3,4,6,7};
//  set<int> aa(va,va+6);
//  int vb[] = {1,2,4,5,6};
//  set<int> bb(vb,vb+5);
//  
//  cout << (aa<bb) << endl;

 Mesh dual = globmesh.DualMesh();
/* Mesh dual = locmesh.DualMesh();*/
//  cout << "Duales Mesh\n";
//  cout << dual;

 vector< vector<int> > nn = dual.GetMeshArrays();
 
 // Check output
/* cout <<"\n\n+++++++  elements per node  ++++++++++++" << endl; 
 cout << nn;*/
 
 //---------------------------------------------------------
 //  Derive proc per node
 for (unsigned int i=0; i<nn.size(); ++i)
 {
   vector<int> &ni = nn[i];
 //  1st: substitute element number by process number
   for (unsigned int j=0; j<ni.size(); ++j)
   {
	 ni[j] = elmdist[ni[j]];
   }
 //  2nd: sort proc. numbers.
   sort( ni.begin(), ni.end() );
 //  3rd: remove multiple entries
   ni.erase( unique( ni.begin(), ni.end() ), ni.end() );
 }
 //  4th erase all sets of processors that do not include "myrank" 
 //  This changes also from global to local node numbering in "nn".
//  vector< vector <int> >::iterator pp;
//  for (pp=nn.begin(); pp != nn.end(); ++pp)
//  {
//    vector<int>::iterator pi = find( pp->begin(), pp->end(), myrank );
//    if ( pi == pp->end() )   // "myrank" not in group
//    {
//      pp = nn.erase(pp);
//      --pp;
//    }
//  }

 vector< vector<int> > nn_save(nn);
//  cout <<"\n\n+++++++  procs per node  ++++++++++++" << endl;
//  cout << nn;
//  
 
 //  5th:  sort the sets of processors  ----------------------------------
 
 sort( nn.begin(), nn.end(), smaller );
 nn.erase( unique( nn.begin(), nn.end() ), nn.end() );
 cout <<"\n\n+++++++  processor groups  " << myrank << " ++++++++++++" << endl;
 cout << nn;


//##############################################################################
//
//  Locale Comm-groups sammeln und ordnen (spater verteilen)
//
//##############################################################################
//  const int root=0;
//  const int lcount = nn.size();
//        int gcount;
//  
//  // global number of (duplicated) process groups
//  icomm.Allreduce( &lcount, &gcount, 1, MPI::INT, MPI::SUM );
//  cout << "lcount:  " << lcount << "    " << gcount << endl;
//  
//  const int lnn_size=nn.size()*numprocs;
//  int *lln = new int [lnn_size];
//  //   local data
//  int count = 0;
//  for (unsigned int i=0; i<nn.size(); ++i )
//  {
//   vector<int> &ni  = nn[i];
//   for (unsigned int j=0; j<ni.size(); ++j, ++count)
//         lln[count] = ni[j];
//   for (int j=ni.size(); j<numprocs; ++j, ++count)
//         lln[count] = -1;
//  }
//  
// //  for (int i=0; i<count; ++i)  cout << "   " << lln[i];
// //  cout << endl;
//  
//  // provide buffers on root processor
//  int *rcounts = new int[numprocs];
//  icomm.Gather(&lnn_size, 1, MPI::INT, rcounts, 1, MPI::INT, root);
//  
//  int *displ = new int[numprocs+1];
//  if (myrank==root)
//  {
//    displ[0]=0; 
//    for (int i=1; i<=numprocs; ++i)   displ[i] = displ[i-1]+rcounts[i-1];
//    cout << "Lenghth  " <<displ[numprocs] << endl;
//  }
//  
//  int *rbuf = new int [displ[numprocs]];
//  
//  icomm.Gatherv( lln, lnn_size, MPI::INT,
//                  rbuf, rcounts, displ, MPI::INT, root  );
//  
//  if (myrank==root)
//  {
//    for (int i=0; i < numprocs; ++i)
//    {
//      for (int j=displ[i]; j < displ[i+1]; ++j)
//         cout << "  " << rbuf[j];
//      cout << endl;
//    }
//    
//    vector<int> tmp(numprocs);
//    vector< vector<int> > ggroups;
//    ggroups.reserve(gcount);
//    
//    for (int i=0; i < numprocs; ++i)
//    {
//      for (int j=displ[i]; j < displ[i+1]; j+=numprocs)
//      {
//        tmp.clear();
//        for (int k=j; rbuf[k]>=0 && k<j+numprocs; k++)
//        {
//          tmp.push_back(rbuf[k]);
//        }
//        ggroups.push_back(tmp);
//      }
//    }
//    
//   //  2nd: sort proc. numbers.
//    sort( ggroups.begin(), ggroups.end(), smaller);
//  //  3rd: remove multiple entries
//    ggroups.erase( unique( ggroups.begin(), ggroups.end() ), ggroups.end() );
//   
//      cout << ggroups;
// 
//   
//   }
// 
//  
//   delete [] rbuf; delete [] displ; delete [] rcounts;
//  
//  
//  
//  
//  
//  
//  int *ggn = new int [gcount*numprocs];
// 
//  
// 
// 
// 
//  delete [] ggn;
//  delete [] lln;
//##############################################################################
//  Calls Communication aufbauen
//##############################################################################

  vector<Communicator*> groups;
  groups.reserve(nn.size());
  for (unsigned int i=0; i < nn.size(); ++i)
  {
/*    cout << "  -->  " << i << endl;*/
    groups.push_back( new Communicator( icomm,  nn[i], nn_save ) );
  }
//##############################################################################
// und Testen.
//##############################################################################
  for (unsigned int i=0; i < nn.size(); ++i)
  {
/*    cout << myrank << "   <--  ";
    const vector<int> tt = groups[i]->getProcs();
    for (unsigned int j=0; j<tt.size(); ++j )
    {
      cout << "   :::  " << tt[j];
    }
    if (!groups[i]->isValid())  cout << "[ ]";
    cout << endl;*/
    
    if (groups[i]->isValid())
    {
      groups[i]->getComm().Barrier();
    }
  }
//##############################################################################
//  Vector of Communication groups auf gltige reduzieren
//##############################################################################
  vector<Communicator*> red_groups;
  for (unsigned int i=0; i < groups.size(); ++i)
  {
    if (groups[i]->isValid())
    {
      red_groups.push_back(groups[i]);
    }
  }

  for (unsigned int i=0; i < red_groups.size(); ++i)
  {
    red_groups[i]->getComm().Barrier();
  }  
  
//##############################################################################
  cout << "proc.  " << myrank << "  is back.\n";

   icomm.Barrier();
   if (myrank==0)  {int k; cin >> k;}
   icomm.Barrier();
   MPI::Finalize();
 return 0;
}
